## libvpl 2.14.0

=== CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

cmake_minimum_required(VERSION 3.13.0)
if(MSVC)
  cmake_policy(SET CMP0091 NEW)
endif()

file(STRINGS "version.txt" version_txt)
project(vpl VERSION ${version_txt})

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Project configuration options
#

# Set default build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Default CMAKE_BUILD_TYPE not set using Release")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

# More code hardening on Windows
if(MSVC)
  if(${use_control_flow_guard})
    message("Setting CONTROL FLOW GUARD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
    set(CMAKE_EXE_LINKER_FLAGS "/guard:cf /DYNAMICBASE")
  endif()
  if(${use_qspectre})
    message("Setting QSPECTRE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
  endif()
endif()

# Project options
option(BUILD_SHARED_LIBS "Build shared instead of static libraries." ON)
option(BUILD_TESTS "Build tests." OFF)

set(INSTALL_DEV
    ON
    CACHE BOOL "Install files that are only needed for development.")
set(INSTALL_LIB
    ON
    CACHE BOOL "Install dispatcher library.")
set(BUILD_EXAMPLES
    OFF
    CACHE BOOL "Build examples when building dev package.")

set(BUILD_EXPERIMENTAL
    ON
    CACHE BOOL "Build dispatcher with EXPERIMENTAL APIs.")

if(UNIX)
  set(ENABLE_LIBDIR_IN_RUNTIME_SEARCH
      OFF
      CACHE BOOL "Include installation lib directory in runtime search path.")
endif()

option(USE_MSVC_STATIC_RUNTIME
       "Link MSVC runtime statically to all components." OFF)

if(USE_MSVC_STATIC_RUNTIME)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

# Set output directories
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

include(cmake/InstallDirs.cmake)
include(cmake/PackageTarget.cmake)

# Set POSITION_INDEPENDENT_CODE property for all targets
set(CMAKE_POSITION_INDEPENDENT_CODE true)

# Keep executable bits on shared objects when installing regardless of distro
set(CMAKE_INSTALL_SO_NO_EXE 0)

include(cmake/CompileOptions.cmake)

if(BUILD_TESTS)
  include(CTest)
  enable_testing()
endif()

add_subdirectory(api)
add_subdirectory(libvpl)
if(INSTALL_DEV)
  add_subdirectory(env)
  add_subdirectory(examples)
endif()

install(
  FILES third-party-programs.txt
  DESTINATION ${VPL_INSTALL_LICENSEDIR}
  COMPONENT ${VPL_COMPONENT_LIB})

install(
  FILES LICENSE
  RENAME license.txt
  DESTINATION ${VPL_INSTALL_LICENSEDIR}
  COMPONENT ${VPL_COMPONENT_LIB})

if(INSTALL_LIB)
  set(CMAKE_INSTALL_SYSTEM_RUNTIME_COMPONENT ${VPL_COMPONENT_LIB})
  include(InstallRequiredSystemLibraries)
endif()

message(
  STATUS "---------------- Configuration summary ------------------------------"
)
message(STATUS "CMake:")
message(STATUS "  CMAKE_VERSION                   : ${CMAKE_VERSION}")
message(STATUS "  CMAKE_GENERATOR                 : ${CMAKE_GENERATOR}")
message(STATUS "  CMAKE_BUILD_TOOL                : ${CMAKE_BUILD_TOOL}")
message(STATUS "Target:")
message(STATUS "  CMAKE_SYSTEM_NAME               : ${CMAKE_SYSTEM_NAME}")
message(STATUS "  CMAKE_SYSTEM_VERSION            : ${CMAKE_SYSTEM_VERSION}")
message(STATUS "  CMAKE_SYSTEM_PROCESSOR          : ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "General:")
message(STATUS "  CMAKE_BUILD_TYPE                : ${CMAKE_BUILD_TYPE}")
message(STATUS "  CMAKE_TOOLCHAIN_FILE            : ${CMAKE_TOOLCHAIN_FILE}")
message(STATUS "  CMAKE_C_COMPILER                : ${CMAKE_C_COMPILER}")
message(STATUS "  CMAKE_CXX_COMPILER              : ${CMAKE_CXX_COMPILER}")
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(STATUS "  Build architecture              : 64-bit")
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  message(STATUS "  Build architecture              : 32-bit")
endif()
message(STATUS "Flags:")
message(STATUS "  CMAKE_C_FLAGS                   : ${CMAKE_C_FLAGS}")
message(STATUS "  CMAKE_CXX_FLAGS                 : ${CMAKE_CXX_FLAGS}")
message(STATUS "Release flags:")
message(STATUS "  CMAKE_C_FLAGS_RELEASE           : ${CMAKE_C_FLAGS_RELEASE}")
message(STATUS "  CMAKE_CXX_FLAGS_RELEASE         : ${CMAKE_CXX_FLAGS_RELEASE}")
message(STATUS "Debug flags:")
message(STATUS "  CMAKE_C_FLAGS_DEBUG             : ${CMAKE_C_FLAGS_DEBUG}")
message(STATUS "  CMAKE_CXX_FLAGS_DEBUG           : ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "RelWithDebRT flags:")
message(
  STATUS "  CMAKE_C_FLAGS_RELWITHDEBRT      : ${CMAKE_C_FLAGS_RELWITHDEBRT}")
message(
  STATUS "  CMAKE_CXX_FLAGS_RELWITHDEBRT    : ${CMAKE_CXX_FLAGS_RELWITHDEBRT}")
message(STATUS "Install:")
message(STATUS "  CMAKE_INSTALL_PREFIX            : ${CMAKE_INSTALL_PREFIX}")
message(
  STATUS "  CMAKE_INSTALL_FULL_BINDIR       : ${CMAKE_INSTALL_FULL_BINDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_INCLUDEDIR   : ${CMAKE_INSTALL_FULL_INCLUDEDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_LIBDIR       : ${CMAKE_INSTALL_FULL_LIBDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_DOCDIR       : ${CMAKE_INSTALL_FULL_DOCDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_PKGCONFIGDIR   : ${VPL_INSTALL_FULL_PKGCONFIGDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_CMAKEDIR       : ${VPL_INSTALL_FULL_CMAKEDIR}")
message(STATUS "  VPL_INSTALL_FULL_ENVDIR         : ${VPL_INSTALL_FULL_ENVDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_MODFILEDIR     : ${VPL_INSTALL_FULL_MODFILEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_EXAMPLEDIR     : ${VPL_INSTALL_FULL_EXAMPLEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_LICENSEDIR     : ${VPL_INSTALL_FULL_LICENSEDIR}")
message(STATUS "  INSTALL_DEV                     : ${INSTALL_DEV}")
message(STATUS "  INSTALL_LIB                     : ${INSTALL_LIB}")
message(STATUS "Build:")
message(STATUS "  BUILD_SHARED_LIBS               : ${BUILD_SHARED_LIBS}")
message(STATUS "  BUILD_TESTS                     : ${BUILD_TESTS}")
message(STATUS "  BUILD_EXAMPLES                  : ${BUILD_EXAMPLES}")
message(STATUS "  BUILD_EXPERIMENTAL              : ${BUILD_EXPERIMENTAL}")
if(UNIX)
  message(
    STATUS
      "  ENABLE_LIBDIR_IN_RUNTIME_SEARCH : ${ENABLE_LIBDIR_IN_RUNTIME_SEARCH}")
endif()
if(MSVC)
  message(
    STATUS "  USE_MSVC_STATIC_RUNTIME         : ${USE_MSVC_STATIC_RUNTIME}")
endif()

=== api/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

cmake_minimum_required(VERSION 3.13.0)

set(VPL_API_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

if(DEFINED ENV{ONEVPL_API_HEADER_DIRECTORY})
  set(VPL_API_INCLUDE_DIR $ENV{ONEVPL_API_HEADER_DIRECTORY})
  message(STATUS "Using custom API header directory: ${VPL_API_INCLUDE_DIR}")
endif()

# get API version
file(READ ${VPL_API_INCLUDE_DIR}/vpl/mfxdefs.h mfxdefs)

string(REGEX MATCH "MFX_VERSION_MAJOR ([0-9]*)" _ ${mfxdefs})
set(API_VERSION_MAJOR ${CMAKE_MATCH_1})
set(API_VERSION_MAJOR
    ${API_VERSION_MAJOR}
    PARENT_SCOPE)

string(REGEX MATCH "MFX_VERSION_MINOR ([0-9]*)" _ ${mfxdefs})
set(API_VERSION_MINOR ${CMAKE_MATCH_1})
set(API_VERSION_MINOR
    ${API_VERSION_MINOR}
    PARENT_SCOPE)

message(STATUS "API version: ${API_VERSION_MAJOR}.${API_VERSION_MINOR}")
add_library(vpl-api INTERFACE)

target_include_directories(vpl-api INTERFACE ${VPL_API_INCLUDE_DIR})

if(INSTALL_DEV)
  install(
    DIRECTORY ${VPL_API_INCLUDE_DIR}/vpl
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    COMPONENT ${VPL_COMPONENT_DEV})
endif()

=== env/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)

file(RELATIVE_PATH env_rel_prefix "${VPL_INSTALL_FULL_ENVDIR}"
     "${CMAKE_INSTALL_PREFIX}")
# remove trailing slash
string(REGEX REPLACE "\/$" "" env_rel_prefix "${env_rel_prefix}")

# convert to native path
file(TO_NATIVE_PATH "${env_rel_prefix}" env_rel_prefix)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_INCLUDEDIR}" _install_includedir)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_LIBDIR}" _install_libdir)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_BINDIR}" _install_bindir)
file(TO_NATIVE_PATH "${VPL_INSTALL_EXAMPLEDIR}" _install_exampledir)

if(WIN32)
  install(
    PROGRAMS "cmd/vars.bat"
    DESTINATION "${VPL_INSTALL_ENVDIR}"
    COMPONENT ${VPL_COMPONENT_DEV})

  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(ENV_SCRIPT_NAME "vars64.bat")
  elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(ENV_SCRIPT_NAME "vars32.bat")
  endif()
  configure_file("cmd/varsxx.bat.in" "${ENV_SCRIPT_NAME}" @ONLY)

  install(
    PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/${ENV_SCRIPT_NAME}"
    DESTINATION "${VPL_INSTALL_ENVDIR}"
    COMPONENT ${VPL_COMPONENT_DEV})
else()
  file(TO_CMAKE_PATH "${env_rel_prefix}" env_rel_prefix)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_INCLUDEDIR}" _install_includedir)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_LIBDIR}" _install_libdir)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_BINDIR}" _install_bindir)
  file(TO_CMAKE_PATH "${VPL_INSTALL_PKGCONFIGDIR}" _install_pkgconfigdir)
  set(ENV_SCRIPT_NAME "vars.sh")
  configure_file("sh/vars.sh.in" "${ENV_SCRIPT_NAME}" @ONLY)
  install(
    PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/${ENV_SCRIPT_NAME}"
    DESTINATION "${VPL_INSTALL_ENVDIR}"
    COMPONENT ${VPL_COMPONENT_DEV})
endif()

=== examples/api2x/hello-sharing-vaapi/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(hello-sharing-vaapi)

# Enable experimental mode
add_compile_definitions(ONEVPL_EXPERIMENTAL)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(VAAPI_TARGETS hello-sharing-vaapi-export hello-sharing-vaapi-import)
foreach(target IN LISTS VAAPI_TARGETS)
  set(TARGET ${target})
  set(SOURCES src/${target}.cpp src/device-vaapi.cpp)
  add_executable(${target} ${SOURCES})
  target_include_directories(${target}
                             PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)

  # Set default build type to RelWithDebInfo if not specified
  if(NOT CMAKE_BUILD_TYPE)
    message(
      STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
    set(CMAKE_BUILD_TYPE
        "RelWithDebInfo"
        CACHE
          STRING
          "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
          FORCE)
  endif()

  if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    if(NOT DEFINED ENV{VSCMD_VER})
      set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
    endif()
  endif()

  find_package(VPL REQUIRED)
  target_link_libraries(${target} PRIVATE VPL::dispatcher)

  if(UNIX)
    set(LIBVA_SUPPORT
        ON
        CACHE BOOL "Enable hardware support.")
    if(LIBVA_SUPPORT)
      find_package(PkgConfig REQUIRED)
      find_package(Threads REQUIRED)
      # note: pkg-config version for libva is *API* version
      pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
      pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
      if(PKG_LIBVA_FOUND)
        target_compile_definitions(${target} PUBLIC -DLIBVA_SUPPORT)
        set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
        set(THREADS_PREFER_PTHREAD_FLAG TRUE)
        target_link_libraries(${target} PRIVATE Threads::Threads)
        target_link_libraries(${target} PRIVATE PkgConfig::PKG_LIBVA
                                                PkgConfig::PKG_LIBVA_DRM)
        target_include_directories(${target} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
      else()
        message(
          SEND_ERROR
            "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
        )
      endif()
    else()
      message(STATUS "Building ${TARGET} without hardware support")
    endif()
  endif()

  install(TARGETS ${target} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                    COMPONENT ${VPL_COMPONENT_DEV})
endforeach()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")

# Import test
add_test(NAME hello-sharing-vaapi-import-test
         COMMAND hello-sharing-vaapi-import -i
                 "${VPL_CONTENT_DIR}/cars_320x240.nv12" -w 320 -h 240)
set(passRegex "Encoded 30 frames" "^All ok")
set_property(TEST hello-sharing-vaapi-import-test
             PROPERTY PASS_REGULAR_EXPRESSION "${passRegex}")

# Export test
add_test(NAME hello-sharing-vaapi-export-test
         COMMAND hello-sharing-vaapi-export -i
                 "${VPL_CONTENT_DIR}/cars_320x240.h265")
set(passRegex "Decoded 30 frames" "^All ok")
set_property(TEST hello-sharing-vaapi-export-test
             PROPERTY PASS_REGULAR_EXPRESSION "${passRegex}")

=== examples/api2x/hello-transcode/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(hello-transcode)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(CMAKE_LIBRARY_ARCHITECTURE x86)
endif()

if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET hello-transcode)
set(SOURCES src/hello-transcode.cpp)

# Set default build type to RelWithDebInfo if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(
    STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

add_executable(${TARGET} ${SOURCES})

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::dispatcher)

if(UNIX)
  set(LIBVA_SUPPORT
      ON
      CACHE BOOL "Enable hardware support.")
  if(LIBVA_SUPPORT)
    find_package(PkgConfig REQUIRED)
    # note: pkg-config version for libva is *API* version
    pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
    pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
    if(PKG_LIBVA_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
      set(THREADS_PREFER_PTHREAD_FLAG TRUE)
      find_package(Threads REQUIRED)
      target_link_libraries(${TARGET} PkgConfig::PKG_LIBVA
                            PkgConfig::PKG_LIBVA_DRM Threads::Threads)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
    else()
      message(
        SEND_ERROR
          "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
      )
    endif()
  else()
    message(STATUS "Building ${TARGET} without hardware support")
  endif()
endif()

# copy dependent dlls to target location
if(WIN32)
  if(${CMAKE_VERSION} VERSION_LESS "3.26")
    message(
      STATUS
        "CMake Version less than 3.26, unable to copy dependent DLLs to target location"
    )
  else()
    add_custom_command(
      TARGET ${TARGET}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:${TARGET}>
              $<TARGET_RUNTIME_DLLS:${TARGET}>
      COMMAND_EXPAND_LISTS)
  endif()
endif()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")
add_test(NAME ${TARGET}-test COMMAND ${TARGET} -i
                                     "${VPL_CONTENT_DIR}/cars_320x240.mjpeg")

=== libvpl/test/unit/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)

set(TARGET vpl-tests)
set(test_sources
    src/session-test.cpp
    src/legacycpp-session-test-1x.cpp
    src/legacycpp-session-test-2x.cpp
    src/main.cpp
    src/dispatcher_common.cpp
    src/dispatcher_common_multiprop.cpp
    src/dispatcher_enum_impls.cpp
    src/dispatcher_gpu.cpp
    src/dispatcher_low_latency.cpp
    src/dispatcher_stub.cpp
    src/dispatcher_sw.cpp
    src/dispatcher_sw_multiprop.cpp
    src/dispatcher_util.cpp
    src/dispatcher_gpu_stringapi.cpp
    src/dispatcher_stub_stringapi.cpp
    src/experimental_api.cpp)
add_executable(${TARGET} ${test_sources})

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} PUBLIC GTest::gtest VPL::dispatcher)

target_include_directories(${TARGET} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

if(WIN32)
  target_link_libraries(${TARGET} PUBLIC shlwapi.lib)
endif()

include(GoogleTest)
# note that RESOURCE_LOCK prevents running any discoveded tests in parallel
gtest_discover_tests(
  ${TARGET} PROPERTIES ENVIRONMENT
  ONEVPL_SEARCH_PATH=$<TARGET_FILE_DIR:vplstubrt> RESOURCE_LOCK
  DISPATCHER_LOG_FILE)

=== libvpl/test/diagnostic/vpl-timing/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  set(LIBS version)
endif()

add_executable(vpl-timing src/vpl-timing.cpp)
target_link_libraries(vpl-timing VPL ${LIBS})
target_include_directories(vpl-timing PRIVATE ${ONEVPL_API_HEADER_DIRECTORY})

=== libvpl/test/runtimes/stub1x/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
# Build stub runtime for testing Intel® Video Processing Library (Intel® VPL)
cmake_minimum_required(VERSION 3.13.0)
set(DLL_PREFIX "lib")
file(STRINGS "../stub/version.txt" version_txt)
project(vplstubrt1x VERSION ${version_txt})

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(OUTPUT_NAME ${PROJECT_NAME}64)
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(OUTPUT_NAME ${PROJECT_NAME}32)
endif()

# add lib/<arch> to find_package path on windows
if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(CMAKE_LIBRARY_ARCHITECTURE x86)
endif()

add_library(${PROJECT_NAME} SHARED "")

add_definitions(-DENABLE_STUB_1X)

if(WIN32)
  # force libxxx style sharedlib name on Windows
  set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX ${DLL_PREFIX})
  set(SHLIB_FILE_NAME ${DLL_PREFIX}${OUTPUT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX})
  set(SHLIB_FILE_NAME_DEBUG
      ${DLL_PREFIX}${OUTPUT_NAME}${CMAKE_DEBUG_POSTFIX}${CMAKE_SHARED_LIBRARY_SUFFIX}
  )
else()
  set(SHLIB_FILE_NAME
      ${CMAKE_SHARED_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}.${PROJECT_VERSION_MAJOR}
  )
endif()

set(IMPLIB_FILE_NAME
    ${CMAKE_IMPORT_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_IMPORT_LIBRARY_SUFFIX})
set(IMPLIB_FILE_NAME_DEBUG
    ${CMAKE_IMPORT_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_DEBUG_POSTFIX}${CMAKE_IMPORT_LIBRARY_SUFFIX}
)

set_target_properties(
  ${PROJECT_NAME}
  PROPERTIES OUTPUT_NAME ${OUTPUT_NAME} SOVERSION ${PROJECT_VERSION_MAJOR}
             VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR})

target_sources(${PROJECT_NAME} PRIVATE ../stub/src/stubs.cpp
                                       ../stub/src/config.cpp)

if(WIN32)
  target_sources(${PROJECT_NAME} PRIVATE ../stub/src/windows/libvplminrt.def)
endif()

find_package(VPL 2.2 REQUIRED COMPONENTS api)
message(STATUS "Found Intel® VPL (version ${VPL_VERSION})")
target_link_libraries(${PROJECT_NAME} PUBLIC VPL::api)

target_include_directories(${PROJECT_NAME} PRIVATE ../stub
                                                   ${CMAKE_CURRENT_BINARY_DIR})

target_compile_definitions(
  ${PROJECT_NAME}
  PRIVATE -DVERSION_MAJOR=${PROJECT_VERSION_MAJOR}
          -DVERSION_MINOR=${PROJECT_VERSION_MINOR}
          -DVERSION_PATCH=${PROJECT_VERSION_PATCH})

if(UNIX)
  set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS
                                                   -Wl,-Bsymbolic,-z,defs)
endif()

=== debian/changelog ===
libvpl (1:2.14.0-1) unstable; urgency=medium

  * New upstream release.
  * control, rules: Build examples, add libvpl-examples.
  * control, install: Move examples source to -examples, add B/R on old
    libvpl-dev.
  * Rename source/repo to libvpl to match upstream.
  * rules: Drop useless override.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 29 Jan 2025 20:21:42 +0200

onevpl (1:2.13.0-1) unstable; urgency=medium

  * New upstream release.
    - new versioning scheme, bump the epoch
  * control: Update descriptions, drop onevpl-tools.
  * control: Migrate to pkgconf.
  * control: Bump standards to 4.7.0, no changes.
  * Update upstream repo to intel/libvpl.
  * install: Updated.
  * control: Drop useless build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 07 Sep 2024 11:22:27 +0300

onevpl (2023.3.0-1) unstable; urgency=medium

  * New upstream release.
  * rules: Fix env/moduledir destinations.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 19 Jun 2023 16:23:29 +0300

onevpl (2023.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 10 Jan 2023 16:55:32 +0200

onevpl (2023.1.0-1) unstable; urgency=medium

  * New upstream release.
  * control: libvpl-dev should depend on libvpl2. (Closes: #1025500)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 08 Dec 2022 13:25:09 +0200

onevpl (2022.2.4-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 18 Oct 2022 14:29:10 +0300

onevpl (2022.2.2-1) unstable; urgency=medium

  * New upstream release.
  * control: Add missing build-deps.
  * rules, install: Fix install paths.
  * install: Add examples to -dev.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 26 Aug 2022 13:20:13 +0300

onevpl (2022.1.0-2) unstable; urgency=medium

  * control: Limit architecture to amd64, x32. (Closes: #1008866)

 -- Timo Aaltonen <tjaalton@debian.org>  Sun, 03 Apr 2022 11:34:46 +0300

onevpl (2022.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 02 Apr 2022 06:44:42 +0300

onevpl (2022.0.4-1) unstable; urgency=medium

  * Initial release (Closes: #1003279)

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 11 Feb 2022 10:36:44 +0200

=== debian/control ===
Source: libvpl
Section: libs
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libva-dev,
 pkgconf,
Standards-Version: 4.7.0
Homepage: https://github.com/intel/libvpl
Vcs-Browser: https://salsa.debian.org/debian/libvpl
Vcs-Git: https://salsa.debian.org/debian/libvpl.git
Rules-Requires-Root: no

Package: libvpl2
Architecture: amd64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel Video Processing Library -- shared library
 Intel Video Processing Library (Intel VPL) provides access to hardware
 accelerated video decode, encode, and processing capabilities on Intel
 GPUs to support AI visual inference, media delivery, cloud gaming, and virtual
 desktop infrastructure use cases.
 .
 This repository contains the following components:
 .
  - Copies of the Intel® VPL API header files
  - Intel VPL Dispatcher
  - Examples demonstrating API usage
 .
 This package includes the dispatcher library.

Package: libvpl-dev
Architecture: amd64 x32
Depends:
 libvpl2 (= ${binary:Version}),
 ${misc:Depends},
Description: Intel Video Processing Library -- development files
 Intel Video Processing Library (Intel VPL) provides access to hardware
 accelerated video decode, encode, and processing capabilities on Intel
 GPUs to support AI visual inference, media delivery, cloud gaming, and virtual
 desktop infrastructure use cases.
 .
 This repository contains the following components:
 .
  - Copies of the Intel® VPL API header files
  - Intel VPL Dispatcher
  - Examples demonstrating API usage
 .
 This package includes header files and examples for development.

Package: libvpl-examples
Architecture: amd64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libvpl-dev (<< 1:2.14.0-1)
Replaces: libvpl-dev (<< 1:2.14.0-1)
Description: Intel Video Processing Library -- example binaries
 Intel Video Processing Library (Intel VPL) provides access to hardware
 accelerated video decode, encode, and processing capabilities on Intel
 GPUs to support AI visual inference, media delivery, cloud gaming, and virtual
 desktop infrastructure use cases.
 .
 This repository contains the following components:
 .
  - Copies of the Intel® VPL API header files
  - Intel VPL Dispatcher
  - Examples demonstrating API usage
 .
 This package includes example binaries.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_EXAMPLES=ON \
		-DVPL_INSTALL_ENVDIR=/usr/share/vpl/env \
		-DVPL_INSTALL_MODFILEDIR=/usr/share/vpl/modulefiles
